# wxTextCompleter Class Reference

`#include <wx/textcompleter.h>`

Inheritance diagram for wxTextCompleter:
[legend]

## Detailed Description

Base class for custom text completer objects.

Custom completer objects used with wxTextEntry::AutoComplete() must derive from this class and implement its pure virtual method returning the completions. You would typically use a custom completer when the total number of completions is too big for performance to be acceptable if all of them need to be returned at once but if they can be generated hierarchically, i.e. only the first component initially, then the second one after the user finished entering the first one and so on.

When inheriting from this class you need to implement its two pure virtual methods. This allows to return the results incrementally and may or not be convenient depending on where do they come from. If you prefer to return all the completions at once, you should inherit from wxTextCompleterSimple instead.

Since:
  2.9.2

## Public Member Functions
virtual bool | Start (const wxString &prefix)=0
| Function called to start iteration over the completions for the given prefix.
virtual wxString | GetNext ()=0
| Called to retrieve the next completion.

List of all members.

## Member Function Documentation

virtual wxString wxTextCompleter::GetNext | ( |  | ) | `[pure virtual]`

Called to retrieve the next completion.

All completions returned by this function should start with the prefix passed to the last call to Start().

Notice that, as Start(), this method is called from a worker thread context under MSW.

Returns:
  The next completion or an empty string to indicate that there are no more of them.

virtual bool wxTextCompleter::Start | ( | const wxString & | prefix | ) | `[pure virtual]`

Function called to start iteration over the completions for the given prefix.

This function could start a database query, for example, if the results are read from a database.

Notice that under some platforms (currently MSW only) it is called from another thread context and so the appropriate synchronization mechanism should be used to access any data also used by the main UI thread.

Parameters:

  | prefix | The prefix for which completions are to be generated.

Returns:
  true to continue with calling GetNext() or false to indicate that there are no matches and GetNext() shouldn't be called at all.

|  | [ top ]